/*
 * Copyright 2004-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.dao.pager;

/**
 * y[W̃r[wp[NXłB
 * 
 * @author Toshitaka Agata(Nulab,inc.)
 */
public class PagerViewHelper implements PagerCondition {

    private static final int DEFAULT_DISPLAY_PAGE_MAX = 9;

    /** IuWFNg */
    private final PagerCondition condition;

    /** ʏł̃y[W̍ő\ */
    private final int displayPageMax;

    public PagerViewHelper(PagerCondition condition) {
        this(condition, DEFAULT_DISPLAY_PAGE_MAX);
    }

    public PagerViewHelper(PagerCondition condition, int displayPageMax) {
        this.condition = condition;
        this.displayPageMax = displayPageMax;
    }

    public int getCount() {
        return condition.getCount();
    }

    public void setCount(int count) {
        condition.setCount(count);
    }

    public int getLimit() {
        return condition.getLimit();
    }

    public void setLimit(int limit) {
        condition.setLimit(limit);
    }

    public int getOffset() {
        return condition.getOffset();
    }

    public void setOffset(int offset) {
        condition.setOffset(offset);
    }

    /**
     * Oւ̃N\ł邩ǂ𔻒肵܂B
     * @param ture/false
     */
    public boolean isPrev() {
        return PagerUtil.isPrev(condition);
    }

    /**
     * ւ̃N\ł邩ǂ𔻒肵܂B
     * @param ture/false
     */
    public boolean isNext() {
        return PagerUtil.isNext(condition);
    }

    /**
     * ݕ\̈ꗗ̍Ōoffset擾܂B
     * @param ݕ\̈ꗗ̍Ōoffset
     */
    public int getCurrentLastOffset() {
        return PagerUtil.getCurrentLastOffset(condition);
    }

    /**
     * փNoffsetԂ܂B
     * @return փNoffset
     */
    public int getNextOffset() {
        return PagerUtil.getNextOffset(condition);
    }

    /**
     * OփNoffsetԂ܂B
     * @return OփNoffset
     */
    public int getPrevOffset() {
        return PagerUtil.getPrevOffset(condition);
    }

    /**
     * ݃y[W̃CfbNXԂ܂B
     * @return ݃y[W̃CfbNX
     */
    public int getPageIndex() {
        return PagerUtil.getPageIndex(condition);
    }

    /**
     * ݃y[W̃JEg(CfbNX+1)Ԃ܂B
     * @return ݃y[W̃JEg(CfbNX+1)
     */
    public int getPageCount() {
        return PagerUtil.getPageCount(condition);
    }

    /**
     * ŏIy[W̃CfbNXԂ܂B
     * @return ŏIy[W̃CfbNX
     */
    public int getLastPageIndex() {
        return PagerUtil.getLastPageIndex(condition);
    }

    /**
     * y[WN̕\ɁAy[WԍN̕\JnʒuԂ܂B
     * @return y[WԍN̕\Jnʒu
     */
    public int getDisplayPageIndexBegin() {
        return PagerUtil.getDisplayPageIndexBegin(condition, displayPageMax);
    }

    /**
     * y[WN̕\ɁAy[WԍN̕\IʒuԂ܂B
     * @return y[WԍN̕\Iʒu
     */
    public int getDisplayPageIndexEnd() {
        return PagerUtil.getDisplayPageIndexEnd(condition, displayPageMax);
    }
}